/*
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
 * WARRANTY OF ANY KIND, either express or implied. See the License for the specific
 * language governing rights and limitations under the License.
 * 
 * The Original Code is the Venice Web Communities System.
 * 
 * The Initial Developer of the Original Code is Eric J. Bowersox <erbo@silcom.com>,
 * for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
 * Copyright (C) 2002 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
 * 
 * Contributor(s): 
 */
package com.silverwrist.dynamo.db;

import java.util.*;
import com.silverwrist.dynamo.iface.*;
import com.silverwrist.dynamo.except.*;
import com.silverwrist.dynamo.util.*;

abstract class GroupObjectOps extends OpsBase
{
  /*--------------------------------------------------------------------------------
   * Constructor
   *--------------------------------------------------------------------------------
   */

  protected GroupObjectOps(DBConnectionPool pool)
  {
    super(pool);

  } // end constructor

  /*--------------------------------------------------------------------------------
   * Abstract operations
   *--------------------------------------------------------------------------------
   */

  abstract Object getProperty(int gid, PropertyKey key) throws DatabaseException;

  abstract Object setProperty(int gid, PropertyKey key, Object value) throws DatabaseException;

  abstract Object removeProperty(int gid, PropertyKey key) throws DatabaseException;

  abstract int[] getPropertyNamespaceIDs(int gid) throws DatabaseException;

  abstract Map getAllProperties(int gid, int namespace) throws DatabaseException;

  abstract boolean testMember(int gid, int uid) throws DatabaseException;

  abstract boolean addMember(int gid, int uid) throws DatabaseException;

  abstract boolean removeMember(int gid, int uid) throws DatabaseException;

  abstract int[] getMembers(int gid) throws DatabaseException;

  abstract void setAclID(int gid, int aclid) throws DatabaseException;

} // end class GroupObjectOps
